/*
	ChatService object that will be served

	Author : Dattaraj J. Rao		dattarajrao@yahoo.com
*/

import java.rmi.*;
import java.rmi.server.*;

import java.util.*;

public class ChatService extends UnicastRemoteObject implements IChatService
{
	Vector clients;

	public ChatService() throws RemoteException
	{
		super();
		clients=new Vector();
	}

	public void addClient(IChatClient client) throws RemoteException
	{
		if(!clients.contains(client))
		{
			clients.addElement(client);
		}
	}

	public void removeClient(IChatClient client) throws RemoteException
	{
		if(clients.contains(client))
		{
			clients.removeElement(client);
		}
	}

	public void sendMessage(IChatClient client,String msg) throws RemoteException
	{
		if(!clients.contains(client))
			return;

		// Send the message to all clients //
		for(int i=0;i<clients.size();i++)
		{
			String user=client.getName();
			if(user==null || user=="")
				user="anonymous";

			((IChatClient)clients.elementAt(i)).sendMessage(user+" : "+msg);
		}
	}

}